# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# FIXME: this package needs to be split into proper subpkgs w/ proper requires

%bcond_without repolib

%global ivy_version 2.3.0

%define upstreamreltag .Final
%global upstreamversion %{version}%{?upstreamreltag}
%define reltag %{?upstreamreltag}_redhat_1
%define namedreltag .Final-redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           ironjacamar
Version:        1.0.17
Release:        1%{?reltag}%{?dist}
Epoch:          0
Summary:        An implementation of the Java Connector Architecture 1.6 specification
License:        LGPLv2.1+
Group:          Development/Java
URL:            http://www.jboss.org/ironjacamar/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-jca/tags/IRONJACAMAR_1_0_17_FINAL/ ironjacamar-1.0.17.Final
# tar czf ironjacamar-1.0.17.Final.tar.gz ironjacamar-1.0.17.Final
Source0:        ironjacamar-1.0.17.Final.tar.gz
Source1:        ivy.settings.xml
Patch0:         ironjacamar-build.patch
Patch1:         ironjacamar-mvn-pom-template.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       jboss-logging
Requires:       jboss-logmanager
Requires:       picketbox
Requires:       hibernate-beanvalidation-api
Requires:       jboss-threads
Requires:       jboss-jaspi-api_1.0_spec
Requires:       jboss-transaction-api_1.1_spec
Requires:       jboss-transaction-spi
BuildRequires:  java
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant
BuildRequires:  maven-deploy-plugin
BuildRequires:  apache-ivy = 0:%{ivy_version}
BuildRequires:  commons-parent
BuildRequires:  dom4j
BuildRequires:  jdepend
BuildRequires:  jboss-logmanager
BuildRequires:  jboss-threads
BuildRequires:  hibernate-beanvalidation-api
BuildRequires:  jboss-transaction-spi
BuildRequires:  jboss-logging
BuildRequires:  jboss-logging-tools
BuildRequires:  picketbox
BuildRequires:  jboss-jaspi-api_1.0_spec
BuildRequires:  jboss-transaction-api_1.1_spec
BuildRequires:  jboss-parent
BuildRequires:  apiviz
BuildRequires:  codemodel
BuildRequires:  jdeparser
BuildRequires:  apache-commons-compress
BuildRequires:  unzip
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{namedversion}-%{release}-root

%description
An implementation of the Java Connector Architecture 1.6 specification.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
%endif

%prep
%setup -q -n ironjacamar-%{upstreamversion}
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

%{_bindir}/find -type f -name "*.jar" | %{_bindir}/xargs -t %{__rm}
%{_bindir}/find -type f -name "*.zip" | %{_bindir}/xargs -t %{__rm}

# FIXME: this should be a patch
%{_bindir}/find -type f -name build.xml |%{_bindir}/xargs -t %{__sed} -i "s/indexMetaInf=\"true\"//g"

%{__cp} -p %{SOURCE1} .

%build
export LC_ALL=en_US.UTF-8
export ANT_OPTS=
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} -Das=true -Duser.home=`pwd` -Divy.dir=%{_javadir} -Divy.version=%{ivy_version} nexus

%install
%{__rm} -rf %{buildroot}

# parent directory for jars, poms and javadocs, repolib
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}

for artifactId in \
                  ironjacamar-spec-api \
                  ironjacamar-common-api \
                  ironjacamar-common-impl \
                  ironjacamar-common-spi \
                  ironjacamar-core-api \
                  ironjacamar-core-impl \
                  ironjacamar-deployers-common \
                  ironjacamar-jdbc \
                  ironjacamar-validator \
               ; do
# jars
%{__cp} -p target/${artifactId}.jar %{buildroot}%{_javadir}/${artifactId}-%{namedversion}.jar
%{__cp} -p target/${artifactId}-javadoc.jar %{buildroot}%{_javadir}/${artifactId}-%{namedversion}-javadoc.jar
%{__cp} -p target/${artifactId}-sources.jar %{buildroot}%{_javadir}/${artifactId}-%{namedversion}-sources.jar

# poms
%{__cp} -p target/${artifactId}.xml %{buildroot}%{_mavenpomdir}/JPP-${artifactId}.pom
%{__sed} -i "s/<version>.*[^r][^e][^d][^h][^a][^t][^-][^1]<\/version>//g" %{buildroot}%{_mavenpomdir}/JPP-${artifactId}.pom

# depmaps
%add_to_maven_depmap org.jboss.ironjacamar ${artifactId} %{namedversion} JPP ${artifactId}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/${artifactId}
# FIXME: (dwalluck): this is wrong: we need an aggregate javadoc
%{_bindir}/unzip -qq -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/${artifactId} %{buildroot}%{_javadir}/${artifactId}-%{namedversion}-javadoc.jar -x META-INF/\*

# repolib
%if %with repolib
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=`pwd`/.m2/repository deploy:deploy-file \
                      -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-${artifactId}.pom \
                      -Dfile=%{buildroot}%{_javadir}/${artifactId}-%{namedversion}.jar \
                      -Djavadoc=%{buildroot}%{_javadir}/${artifactId}-%{namedversion}-javadoc.jar \
                      -Dsources=%{buildroot}%{_javadir}/${artifactId}-%{namedversion}-sources.jar \
                      -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif
done

(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%clean
%{__rm} -rf %{buildroot}
                                                                                                     
%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/ironjacamar-common-api-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-common-api-sources.jar
%{_javadir}/ironjacamar-common-api-%{namedversion}.jar
%{_javadir}/ironjacamar-common-api.jar
%{_javadir}/ironjacamar-common-impl-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-common-impl-sources.jar
%{_javadir}/ironjacamar-common-impl-%{namedversion}.jar
%{_javadir}/ironjacamar-common-impl.jar
%{_javadir}/ironjacamar-common-spi-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-common-spi-sources.jar
%{_javadir}/ironjacamar-common-spi-%{namedversion}.jar
%{_javadir}/ironjacamar-common-spi.jar
%{_javadir}/ironjacamar-core-api-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-core-api-sources.jar
%{_javadir}/ironjacamar-core-api-%{namedversion}.jar
%{_javadir}/ironjacamar-core-api.jar
%{_javadir}/ironjacamar-core-impl-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-core-impl-sources.jar
%{_javadir}/ironjacamar-core-impl-%{namedversion}.jar
%{_javadir}/ironjacamar-core-impl.jar
%{_javadir}/ironjacamar-deployers-common-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-deployers-common-sources.jar
%{_javadir}/ironjacamar-deployers-common-%{namedversion}.jar
%{_javadir}/ironjacamar-deployers-common.jar
%{_javadir}/ironjacamar-jdbc-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-jdbc-sources.jar
%{_javadir}/ironjacamar-jdbc-%{namedversion}.jar
%{_javadir}/ironjacamar-jdbc.jar
%{_javadir}/ironjacamar-spec-api-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-spec-api-sources.jar
%{_javadir}/ironjacamar-spec-api-%{namedversion}.jar
%{_javadir}/ironjacamar-spec-api.jar
%{_javadir}/ironjacamar-validator-%{namedversion}-sources.jar
%{_javadir}/ironjacamar-validator-sources.jar
%{_javadir}/ironjacamar-validator-%{namedversion}.jar
%{_javadir}/ironjacamar-validator.jar
%{_mavenpomdir}/JPP-ironjacamar-common-api.pom
%{_mavenpomdir}/JPP-ironjacamar-common-impl.pom
%{_mavenpomdir}/JPP-ironjacamar-common-spi.pom
%{_mavenpomdir}/JPP-ironjacamar-core-api.pom
%{_mavenpomdir}/JPP-ironjacamar-core-impl.pom
%{_mavenpomdir}/JPP-ironjacamar-deployers-common.pom
%{_mavenpomdir}/JPP-ironjacamar-jdbc.pom
%{_mavenpomdir}/JPP-ironjacamar-spec-api.pom
%{_mavenpomdir}/JPP-ironjacamar-validator.pom
%{_mavendepmapfragdir}/ironjacamar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%{_javadir}/ironjacamar-common-api-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-common-api-javadoc.jar
%{_javadir}/ironjacamar-common-impl-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-common-impl-javadoc.jar
%{_javadir}/ironjacamar-common-spi-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-common-spi-javadoc.jar
%{_javadir}/ironjacamar-core-api-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-core-api-javadoc.jar
%{_javadir}/ironjacamar-core-impl-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-core-impl-javadoc.jar
%{_javadir}/ironjacamar-deployers-common-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-deployers-common-javadoc.jar
%{_javadir}/ironjacamar-jdbc-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-jdbc-javadoc.jar
%{_javadir}/ironjacamar-spec-api-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-spec-api-javadoc.jar
%{_javadir}/ironjacamar-validator-%{namedversion}-javadoc.jar
%{_javadir}/ironjacamar-validator-javadoc.jar

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Apr 30 2013 Paul Gier <pgier@redhat.com> 0:1.0.17-1
- Upgrade to 1.0.17.Final

* Tue Apr 30 2013 David Walluck <dwalluck@redhat.com> 0:1.0.16-5
- add default (on) for repolib option

* Mon Apr 29 2013 Paul Gier <pgier@redhat.com> 0:1.0.16-4
- Add patch for bz922009

* Mon Apr 15 2013 David Walluck <dwalluck@redhat.com> 0:1.0.16-3
- move javadoc jars to javadoc package
- fix symlinking

* Mon Apr 15 2013 David Walluck <dwalluck@redhat.com> 0:1.0.16-2
- set ivy version via macro, not rpmdb query
- fix incorrect jar names
- fix bad find commands in prep
- BuildRequires: unzip
- fix version macros
- update Group
- remove obsolete repolib
- fix file list

* Wed Mar 27 2013 Lin Gao <lgao@redhat.com> - 0:1.0.16-1.Final_redhat_1
- Upgrade to 1.0.16.Final

* Tue Feb 05 2013 Lin Gao <lgao@redhat.com> - 0:1.0.15-1.Final_redhat_1
- Upgrade to 1.0.15.Final
- Add codemodel in classpath

* Tue Jan 22 2013 David Walluck <dwalluck@redhat.com> 0:1.0.14-2
- fix bad mvn deploy command
- fix macro in comment
- fix bad BR for apache-ivy
- add missing Requires: jpackage-utils and drop unnecessary version req
- set user.home to current dir so ivy files go inside build tree
- fix patch1 backup suffix
- fix some bad macro defs
- update ivy settings to be more consistent
- set LC_ALL

* Mon Dec 24 2012 Lin Gao <lgao@redhat.com> - 0:1.0.14-1.Final_redhat_1
- Upgrade to 1.0.14.Final

* Thu Oct 18 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.13-1.Final_redhat_1
- Upgrade to 1.0.13.Final

* Sun Aug 19 2012 Paul Gier <pgier@redhat.com> - 0:1.0.12-1.Final_redhat_1.1
- Update pom patch with eap 6.0.1 bom

* Fri Aug 17 2012 Lin Gao <lgao@redhat.com> - 0:1.0.12-1.Final_redhat_1
- Upgrade to 1.0.12.Final

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.11-1.Final_redhat_2.3
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.11-1.Final_redhat_1.2
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.11-1.Final_redhat_1.1
- Rebuild using cache signing

* Mon May 07 2012 Lin Gao <lgao@redhat.com> - 0:1.0.11-1.Final_redhat_1
- Upgrade to 1.0.11.Final

* Wed May 02 2012 Lin Gao <lgao@redhat.com> - 0:1.0.10-1.Final_redhat_1
- Upgrade to 1.0.10.Final
- Add Requires components
- Build javadoc using apiviz

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.9-2.Final_redhat_1.1
- Rebuild using cache signing

* Thu Mar 22 2012 Lin Gao <lgao@redhat.com> - 0:1.0.9-2.Final_redhat_1
- change jars install path
- add ironjacamar-spec-api to component-info.xml in repolib
- fix release tag

* Mon Mar 12 2012 Lin Gao <lgao@redhat.com> - 0:1.0.9-1_redhat_1
- upgrade to 1.0.9.Final

* Mon Mar 05 2012 Lin Gao <lgao@redhat.com> - 0:1.0.8-2_redhat_1
- remove version of BR jboss-logging-tools

* Mon Mar 05 2012 Lin Gao <lgao@redhat.com> - 0:1.0.8-1_redhat_1
- upgrade to 1.0.8.Final
- remove META-INF from javadoc
- Requires jpackage-utils in javadoc subpackage

* Tue Jan 17 2012 Lin Gao <lgao@redhat.com> - 0:1.0.7-1_redhat_1
- upgrade to 1.0.7.Final

* Thu Jan 05 2012 Lin Gao <lgao@redhat.com> - 0:1.0.6-1_redhat_1
- upgrade to 1.0.6.Final
- using BOMs in pom
- fix JPP mapping

* Thu Oct 27 2011 Lin Gao <lgao@redhat.com> - 0:1.0.5-1_redhat_1
- upgrade to 1.0.5.Final

* Tue Sep 20 2011 Lin Gao <lgao@redhat.com> - 0:1.0.3-1_redhat_1
- upgrade to 1.0.3.Final
- wolf build phrase

* Mon Jul 25 2011 Lin Gao <lgao@redhat.com> - 0:1.0.1-1
- upgrade to 1.0.1.Final

* Sat Jul 9 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-8
- use jboss-logging-tools 1.0.0.Beta7 to fix jar differs from upstream jar

* Fri Jul 8 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-7
- fix jar differs from upstream jar

* Fri Jul 8 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-6
- fix strange groupId in pom files

* Fri Jul 1 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-5
- put -javadoc.jar to repolib

* Mon Jun 13 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-4
- patch build scripts to build EAP components only
- make ivy.setting.xml to use local repo only
- use jboss-logging-mead and picketbox-mead package

* Thu Jun 9 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-3
- fix description of each packages

* Wed Jun 8 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-2
- Initial spec version
- use ironjacamar 1.0.0.Beta6.1

* Tue May 24 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.0.0-1
- Placeholder
